OGRE: Ogre::GLES2Support Class Reference

| OGRE 2.2.4 Object-Oriented Graphics Rendering Engine

Public Member Functions | List of all members
Ogre::GLES2Support Class Referenceabstract

`#include <OgreGLES2Support.h>`

Inheritance diagram for Ogre::GLES2Support:
[legend]

## Public Member Functions
| GLES2Support ()
virtual | ~GLES2Support ()
virtual void | addConfig ()=0
| Add any special config values to the system. More...
virtual bool | checkExtension (const String &ext) const
| Check if an extension is available. More...
virtual RenderWindow * | createWindow (bool autoCreateWindow, GLES2RenderSystem *renderSystem, const String &windowTitle)=0
virtual ConfigOptionMap & | getConfigOptions (void)
virtual unsigned int | getDisplayMonitorCount () const
| Gets the number of display monitors. More...
const String & | getGLVendor (void) const
| Get vendor information. More...
const DriverVersion & | getGLVersion (void) const
| Get version information. More...
virtual void * | getProcAddress (const char *procname) const =0
| Get the address of a function. More...
const String & | getShaderCachePath (void) const
| Get shader cache path. More...
const String & | getShaderLibraryPath (void) const
| Get shader library path. More...
bool | hasMinGLVersion (int major, int minor) const
| Check if GL Version is supported. More...
virtual void | initialiseExtensions ()
| Initialises GL extensions, must be done AFTER the GL context has been established. More...
virtual RenderWindow * | newWindow (const String &name, unsigned int width, unsigned int height, bool fullScreen, const NameValuePairList *miscParams=0)=0
| Creates a new rendering window. More...
virtual void | setConfigOption (const String &name, const String &value)
void | setShaderCachePath (String path)
| Set shader cache path. More...
void | setShaderLibraryPath (String path)
| Set shader library path. More...
virtual void | start ()=0
| Start anything special. More...
virtual void | stop ()=0
| Stop anything special. More...
virtual String | validateConfig ()=0
| Make sure all the extra options are valid. More...

## Constructor & Destructor Documentation

## ◆ GLES2Support()

Ogre::GLES2Support::GLES2Support | ( |  | ) |
| inline

## ◆ ~GLES2Support()

virtual Ogre::GLES2Support::~GLES2Support | ( |  | ) |
| inlinevirtual

## Member Function Documentation

## ◆ addConfig()

virtual void Ogre::GLES2Support::addConfig | ( |  | ) |
| pure virtual

Add any special config values to the system.

Must have a "Full Screen" value that is a bool and a "Video Mode" value that is a string in the form of wxh

Implemented in Ogre::NaClGLSupport, and Ogre::EGLSupport.

## ◆ checkExtension()

virtual bool Ogre::GLES2Support::checkExtension | ( | const String & | ext | ) | const
| virtual

Check if an extension is available.

## ◆ createWindow()

virtual RenderWindow* Ogre::GLES2Support::createWindow | ( | bool | autoCreateWindow,
|  | GLES2RenderSystem * | renderSystem,
|  | const String & | windowTitle
| ) |  |
| pure virtual

Implemented in Ogre::NaClGLSupport, and Ogre::EGLSupport.

## ◆ getConfigOptions()

virtual ConfigOptionMap& Ogre::GLES2Support::getConfigOptions | ( | void |  | ) |
| virtual

## ◆ getDisplayMonitorCount()

virtual unsigned int Ogre::GLES2Support::getDisplayMonitorCount | ( |  | ) | const
| inlinevirtual

Gets the number of display monitors.

See also
  Root::getDisplayMonitorCount

## ◆ getGLVendor()

const String& Ogre::GLES2Support::getGLVendor | ( | void |  | ) | const
| inline

Get vendor information.

## ◆ getGLVersion()

const DriverVersion& Ogre::GLES2Support::getGLVersion | ( | void |  | ) | const
| inline

Get version information.

## ◆ getProcAddress()

virtual void* Ogre::GLES2Support::getProcAddress | ( | const char * | procname | ) | const
| pure virtual

Get the address of a function.

Implemented in Ogre::NaClGLSupport, and Ogre::EGLSupport.

## ◆ getShaderCachePath()

const String& Ogre::GLES2Support::getShaderCachePath | ( | void |  | ) | const
| inline

Get shader cache path.

## ◆ getShaderLibraryPath()

const String& Ogre::GLES2Support::getShaderLibraryPath | ( | void |  | ) | const
| inline

Get shader library path.

## ◆ hasMinGLVersion()

bool Ogre::GLES2Support::hasMinGLVersion | ( | int | major,
|  | int | minor
| ) |  | const

Check if GL Version is supported.

## ◆ initialiseExtensions()

virtual void Ogre::GLES2Support::initialiseExtensions | ( |  | ) |
| virtual

Initialises GL extensions, must be done AFTER the GL context has been established.

## ◆ newWindow()

virtual RenderWindow* Ogre::GLES2Support::newWindow | ( | const String & | name,
|  | unsigned int | width,
|  | unsigned int | height,
|  | bool | fullScreen,
|  | const NameValuePairList * | miscParams = `0`
| ) |  |
| pure virtual

Creates a new rendering window.

Remarks
  This method creates a new rendering window as specified by the paramteters. The rendering system could be responible for only a single window (e.g. in the case of a game), or could be in charge of multiple ones (in the case of a level editor). The option to create the window as a child of another is therefore given. This method will create an appropriate subclass of RenderWindow depending on the API and platform implementation.

  After creation, this window can be retrieved using getRenderTarget().

Parameters

  name | The name of the window. Used in other methods later like setRenderTarget and getRenderTarget.
  width | The width of the new window.
  height | The height of the new window.
  fullScreen | Specify true to make the window full screen without borders, title bar or menu bar.
  miscParams | A NameValuePairList describing the other parameters for the new rendering window. Options are case sensitive. Unrecognised parameters will be ignored silently. These values might be platform dependent, but these are present for all platforms unless indicated otherwise:
  Key | Type/Values | Default | Description | Notes
  title | Any string | RenderTarget name | The title of the window that will appear in the title bar |
  colourDepth | 16, 32 | Desktop depth | Colour depth of the resulting rendering window; only applies if fullScreen | Win32 Specific
  left | Positive integers | Centred | Screen x coordinate from left |
  top | Positive integers | Centred | Screen y coordinate from left |
  depthBuffer | true, false | true | Use depth buffer | DirectX9 specific
  externalWindowHandle | Win32: HWND as integer GLX: poslong:posint:poslong (display*:screen:windowHandle) or poslong:posint:poslong:poslong (display*:screen:windowHandle:XVisualInfo*) OS X Cocoa: OgreGLView address as an integer. You can pass NSView or NSWindow too, but should perform OgreGLView callbacks into the Ogre manually. iOS: UIWindow address as an integer | 0 (none) | External window handle, for embedding the OGRE render in an existing window |
  externalGLControl | true, false | false | Let the external window control OpenGL i.e. don't select a pixel format for the window, do not change v-sync and do not swap buffer. When set to true, the calling application is responsible of OpenGL initialization and buffer swapping. It should also create an OpenGL context for its own rendering, Ogre will create one for its use. Then the calling application must also enable Ogre OpenGL context before calling any Ogre function and restore its OpenGL context after these calls. | OpenGL specific
  externalGLContext | Context as Unsigned Long | 0 (create own context) | Use an externally created GL context | OpenGL Specific
  parentWindowHandle | Win32: HWND as integer GLX: poslong:posint:poslong (display*:screen:windowHandle) or poslong:posint:poslong:poslong (display*:screen:windowHandle:XVisualInfo*) | 0 (none) | Parent window handle, for embedding the OGRE in a child of an external window |
  contentScalingFactor | Positive Float greater than 1.0 | The default content scaling factor of the screen | Specifies the CAEAGLLayer content scaling factor. Only supported on iOS 4 or greater. This can be useful to limit the resolution of the OpenGL ES backing store. For example, the iPhone 4's native resolution is 960 x 640. Windows are always 320 x 480, if you would like to limit the display to 720 x 480, specify 1.5 as the scaling factor. | iOS Specific |
  externalViewHandle | UIView pointer as an integer | 0 | External view handle, for rendering OGRE render in an existing view | iOS Specific |
  externalViewControllerHandle | UIViewController pointer as an integer | 0 | External view controller handle, for embedding OGRE in an existing view controller | iOS Specific |
  externalSharegroup | EAGLSharegroup pointer as an integer | 0 | External sharegroup, used to shared GL resources between contexts | iOS Specific |
  Full Screen | true, false | false | Specify whether to create the window in full screen mode | OS X Specific |
  MSAA | Positive integer (usually 1, 2, 4, 8, 16) | 1 | Multisample antialiasing factor |
  MSAA_Quality | Depends on RenderSystem and hardware. Currently supports: 0 ... infinite number (depends on HW) | Blank | Full screen antialiasing hint |
  displayFrequency | Refresh rate in Hertz (e.g. 60, 75, 100) | Desktop vsync rate | Display frequency rate, for fullscreen mode |
  vsync | true, false | false | Synchronize buffer swaps to monitor vsync, eliminating tearing at the expense of a fixed frame rate |
  vsyncInterval | 1, 2, 3, 4 | 1 | If vsync is enabled, the minimum number of vertical blanks that should occur between renders. For example if vsync is enabled, the refresh rate is 60 and this is set to 2, then the frame rate will be locked at 30. |
  border | none, fixed, resize | resize | The type of window border (in windowed mode) |
  outerDimensions | true, false | false | Whether the width/height is expressed as the size of the outer window, rather than the content area |
  useNVPerfHUD | true, false | false | Enable the use of nVidia NVPerfHUD |
  gamma | true, false | false | Enable hardware conversion from linear colour space to gamma colour space on rendering to the window. |
  enableDoubleClick | true, false | false | Enable the window to keep track and transmit double click messages. | Win32 Specific
  MSAA | Positive integer (usually 0, 2, 4, 8, 16) | 0 | Full screen antialiasing factor | Android Specific
  CSAA | Positive integer (usually 0, 2, 4, 8, 16) | 0 | Coverage sampling factor (https://www.khronos.org/registry/egl/extensions/NV/EGL_NV_coverage_sample.txt) | Android Specific
  maxColourBufferSize | Positive integer (usually 16, 32) | 32 | Max EGL_BUFFER_SIZE | Android Specific
  minColourBufferSize | Positive integer (usually 16, 32) | 16 | Min EGL_BUFFER_SIZE | Android Specific
  maxStencilBufferSize | Positive integer (usually 0, 8) | 0 | EGL_STENCIL_SIZE | Android Specific
  maxDepthBufferSize | Positive integer (usually 0, 16, 24) | 16 | EGL_DEPTH_SIZE | Android Specific

Implemented in Ogre::NaClGLSupport, Ogre::X11EGLSupport, Ogre::Win32EGLSupport, Ogre::EmscriptenEGLSupport, and Ogre::AndroidEGLSupport.

## ◆ setConfigOption()

virtual void Ogre::GLES2Support::setConfigOption | ( | const String & | name,
|  | const String & | value
| ) |  |
| virtual

Reimplemented in Ogre::NaClGLSupport, and Ogre::EGLSupport.

## ◆ setShaderCachePath()

void Ogre::GLES2Support::setShaderCachePath | ( | String | path | ) |
| inline

Set shader cache path.

## ◆ setShaderLibraryPath()

void Ogre::GLES2Support::setShaderLibraryPath | ( | String | path | ) |
| inline

Set shader library path.

## ◆ start()

virtual void Ogre::GLES2Support::start | ( |  | ) |
| pure virtual

Start anything special.

Implemented in Ogre::NaClGLSupport, and Ogre::EGLSupport.

## ◆ stop()

virtual void Ogre::GLES2Support::stop | ( |  | ) |
| pure virtual

Stop anything special.

Implemented in Ogre::NaClGLSupport, and Ogre::EGLSupport.

## ◆ validateConfig()

virtual String Ogre::GLES2Support::validateConfig | ( |  | ) |
| pure virtual

Make sure all the extra options are valid.

Returns
  string with error message

Implemented in Ogre::NaClGLSupport, and Ogre::EGLSupport.

The documentation for this class was generated from the following file:

- OgreGLES2Support.h